function gp = example2
%objective function
obj = 'x''*sin(x)';
obj_grad = 'sin(x) + (x.*cos(x))';

%constraints
cons = {'-x(1)+1/3', 'sin(x(2))-x(1)', '-x(2)/3+1/4', '(x-[1;1])''*(x-[1;1])/5-1'};
cons_grad = {'[-1; 0]', '[-1; cos(x(2))]', '[0; -1/4]', '2*x/5-[2/5;2/5]'};


%domain
x1 = 0:0.11:5;
x2 = 0:0.11:5;

%start points
x1_start = 2;
x2_start = 2;

%construct the optimization problem
gp = gr_ipa_opt( x1, x2, ...
		 ipa_opt_prob( obj, obj_grad, cons, cons_grad ), ...
		 x1_start, x2_start );
